function prsPickWinMouseCallBacks(value)
global PickWin
global Seis
global PlotState

switch (value)
   case 'btnDown'
      hObj = gco;
      PickWin.PickNum = ClickedOnPick(hObj);
      if PickWin.PickNum > 0
         if strcmp(get(gcf,'selectiontype'),'normal')
            PickWin.Selected = 1;
         elseif strcmp(get(gcf,'selectiontype'),'alt')
            DeletePick(PickWin.PickNum)  
         elseif strcmp(get(gcf,'selectiontype'),'extend')
            ModifyPick  
         end
         return
      end
      
      if PickWin.TraceHandle == hObj & strcmp(get(gcf,'selectiontype'),'normal')
         point = get(gca,'CurrentPoint');
         Time = point(1,1);
         CreateNewPick(Time)
         return
      end

   
      PickWin.PickNum = ClickedOnPhase(hObj);
      if PickWin.PickNum > 0
         ModifyJustPhase
         return
      end

      PickWin.PickNum = ClickedOnHeader(hObj);
      if PickWin.PickNum > 0
         ModifyJustHeader
         return
      end
   
   case 'btnMove'
      if PickWin.Selected
         P = get(gca,'CurrentPoint');
         NewTime = [P(1,1) P(1,1)];
         index = PickWin.IndexArray(PickWin.Current);
         set(PickWin.Pick(PickWin.PickNum).LineHandle,'Xdata',NewTime)
         set(Seis(index).Pick(PickWin.PickNum).LineHandle,'Xdata',NewTime)
         Position = get(PickWin.Pick(PickWin.PickNum).Text1,'Position');
         Position(1) = P(1,1);
         set(PickWin.Pick(PickWin.PickNum).Text1,'Position',Position)
         Position = get(PickWin.Pick(PickWin.PickNum).Text2,'Position');
         Position(1) = P(1,1);
         set(PickWin.Pick(PickWin.PickNum).Text2,'Position',Position)
         Position = get(Seis(index).Pick(PickWin.PickNum).TextHandle,'Position');
         Position(1) = P(1,1);
         set(Seis(index).Pick(PickWin.PickNum).TextHandle,'Position',Position)
         if strcmp(PlotState.TimeUnits , 'Minutes')
            Seis(index).Pick(PickWin.PickNum).Time = Position(1) * 60;
         else
            Seis(index).Pick(PickWin.PickNum).Time = Position(1);
         end
      end
   
   
   
   case 'btnUp'
      if PickWin.Selected
         PickWin.Selected = 0;
      end
   
   
   case 'PreviousSeis'
      if PickWin.Current == 1
         return
      end
      PickWin.NewIndex = PickWin.Current - 1;
      prsUpdateSingleTraceWindow('auto')
   
   
   case 'NextSeis'
      if PickWin.Current == length(PickWin.IndexArray)
         return
      end
      PickWin.NewIndex = PickWin.Current + 1;
      prsUpdateSingleTraceWindow('auto')
   
   otherwise, return
   
end
% -------------------------------------------------------------------------
   





function result = ClickedOnPick(hObj)
global PickWin

result = 0;   
for j=1:PickWin.Npicks
   if hObj == PickWin.Pick(j).LineHandle
      result = j;
      return
   end
end
% -------------------------------------------------------------------------







function result = ClickedOnPhase(hObj)
global PickWin

result = 0;   
for j=1:PickWin.Npicks
   if hObj == PickWin.Pick(j).Text1
      result = j;
      return
   end
end
% -------------------------------------------------------------------------








function result = ClickedOnHeader(hObj)
global PickWin

result = 0;   
for j=1:PickWin.Npicks
   if hObj == PickWin.Pick(j).Text2
      result = j;
      return
   end
end
% -------------------------------------------------------------------------







function DeletePick(index)
global Seis
global PickWin

if PickWin.PickNum >= index
   PickWin.PickNum = PickWin.PickNum -1;
end
delete(PickWin.Pick(index).LineHandle);
delete(PickWin.Pick(index).Text1);
delete(PickWin.Pick(index).Text2);
PickWin.Pick(index) = [];
PickWin.Npicks = PickWin.Npicks - 1;

TrceNum = PickWin.IndexArray(PickWin.Current);
delete(Seis(TrceNum).Pick(index).LineHandle)
delete(Seis(TrceNum).Pick(index).TextHandle)
Seis(TrceNum).Pick(index) = [];
Seis(TrceNum).Npicks = Seis(TrceNum).Npicks - 1;
% --------------------------------------------------------------------






function ModifyPhase
   global PickWin
   global prsPickWinWaitForPick
   global CursorPos

% Display pick popup after first setting its default to current value.
   hPickList = findobj('Tag','prsPickWinPickList');
   if ~hPickList, return, end
   Pos = get(hPickList,'Position');
   Pos(1) = CursorPos(1);
   Pos(2) = CursorPos(2);
   
   string = get(hPickList,'string');
   index = CurrentValue(string, PickWin.Pick(PickWin.PickNum).Phase);
   set(hPickList,'Position',Pos);
   set(hPickList,'Value',index)
   set(hPickList,'Visible','on')
   
   
   % The pick popup is now displayed. Go into an endless loop which is terminated
   % by a callback from the popup control
   prsPickWinWaitForPick = 1;
   while prsPickWinWaitForPick
      drawnow
      if ~prsPickWinWaitForPick,break,end
   end
   
   Phase = string( get(hPickList,'value') );
   SetSeisPhase( Phase, PickWin.PickNum)
   set(hPickList,'Visible','off')
% --------------------------------------------------------------------




function index = CurrentValue(string, value);
   index = 1;
   for j=1:length(string)
      if strcmp(string(j), value)
         index = j;
         return;
      end
   end
% --------------------------------------------------------------------






function ModifyHeader
   global PickWin
   global prsPickWinWaitForHdr
   global CursorPos

   
% Display header popup after first setting its default to current value.
   hHeaderList = findobj('Tag','prsPickWinHdrPopUp');
   if ~hHeaderList, return,end
   Pos = get(hHeaderList,'Position');
   Pos(1) = CursorPos(1);
   Pos(2) = CursorPos(2);
   
   string = get(hHeaderList,'string');
   index = CurrentValue(string, PickWin.Pick(PickWin.PickNum).Header);
   set(hHeaderList,'Position',Pos);
   set(hHeaderList,'Value',index)
   set(hHeaderList,'Visible','on')      

   prsPickWinWaitForHdr = 1;
   while prsPickWinWaitForHdr
      drawnow
      if ~prsPickWinWaitForHdr,break,end
   end

   Header = string( get( hHeaderList,'value') );
   SetSeisHeader(Header, PickWin.PickNum)
   set(hHeaderList,'Visible','off')
% --------------------------------------------------------------------




function ModifyJustPhase
   global PickWin
   global CursorPos
   global LastPhaseSet

   OldPhase = PickWin.Pick(PickWin.PickNum).Phase;
   CursorPos = get(gcf,'CurrentPoint');

   ModifyPhase
   Phase = PickWin.Pick(PickWin.PickNum).Phase;
   ModifyIt = ValidatePhase(Phase, OldPhase, PickWin.PickNum);
   while ModifyIt == 3     % modify selection by hand
      ModifyPhase
      Phase = PickWin.Pick(PickWin.PickNum).Phase;
      ModifyIt = ValidatePhase(Phase, OldPhase, PickWin.PickNum);
   end
   LastPhaseSet = PickWin.Pick(PickWin.PickNum).Phase;
% --------------------------------------------------------------------





function ModifyJustHeader
   global PickWin
   global CursorPos

   OldHeader = PickWin.Pick(PickWin.PickNum).Header;
   CursorPos = get(gcf,'CurrentPoint');
   
   ModifyHeader
   Header = PickWin.Pick(PickWin.PickNum).Header;
   ModifyIt = ValidateHeader(Header, OldHeader, PickWin.PickNum);
   while ModifyIt == 3     % modify by hand
      ModifyHeader
      Header = PickWin.Pick(PickWin.PickNum).Header;
      ModifyIt = ValidateHeader(Header, OldHeader, PickWin.PickNum);
   end
% --------------------------------------------------------------------






function ModifyPick
   global PickWin
   global CursorPos
   global LastPhaseSet

   OldHeader = PickWin.Pick(PickWin.PickNum).Header;
   OldPhase = PickWin.Pick(PickWin.PickNum).Phase;
   
   CursorPos = get(gcf,'CurrentPoint');

   ModifyPhase
   Phase = PickWin.Pick(PickWin.PickNum).Phase;
   ModifyIt = ValidatePhase(Phase, OldPhase, PickWin.PickNum);
   while ModifyIt == 3     % modify selection by hand
      ModifyPhase
      Phase = PickWin.Pick(PickWin.PickNum).Phase;
      ModifyIt = ValidatePhase(Phase, OldPhase, PickWin.PickNum);
   end
   
   LastPhaseSet = Phase;
   ModifyHeader
   Header = PickWin.Pick(PickWin.PickNum).Header;
   ModifyIt = ValidateHeader(Header, OldHeader, PickWin.PickNum);
   while ModifyIt == 3     % modify by hand
      ModifyHeader
      Header = PickWin.Pick(PickWin.PickNum).Header;
      ModifyIt = ValidateHeader(Header, OldHeader, PickWin.PickNum);
   end
% --------------------------------------------------------------------





function SetSeisHeader(Header, PickNum)
global Seis
global PickWin

TrceNum = PickWin.IndexArray(PickWin.Current);
PickWin.Pick(PickNum).Header = Header;
set( PickWin.Pick(PickNum).Text2,'String',Header);
Seis(TrceNum).Pick(PickNum).Header = Header;
set(Seis(TrceNum).Pick(PickNum).TextHandle,'string',...
       Seis(TrceNum).Pick(PickNum).Header);
% --------------------------------------------------------------------





function SetSeisPhase( Phase, PickNum)
global Seis
global PickWin

TrceNum = PickWin.IndexArray(PickWin.Current);
PickWin.Pick(PickNum).Phase = Phase;
set( PickWin.Pick(PickNum).Text1,'String',Phase);
Seis(TrceNum).Pick(PickNum).Phase = Phase;
% --------------------------------------------------------------------





function [Conflict, index] = LookForHeaderConflict(Header,PickNum)
global PickWin

Conflict = 0;
index = 0;
for j=1:PickWin.Npicks
   if j ~= PickNum
      if strcmp(PickWin.Pick(j).Header, Header)
         Conflict = 1;
         index = j;
         return;
      end
   end
end
% --------------------------------------------------------------------





function [Conflict, index] = LookForPhaseConflict(Phase,PickNum)
global PickWin

Conflict = 0;
index = 0;
for j=1:PickWin.Npicks
   if j ~= PickNum
      if strcmp(PickWin.Pick(j).Phase, Phase)
         Conflict = 1;
         index = j;
         return;
      end
   end
end
% --------------------------------------------------------------------






function result = ValidateHeader(Header, OldHeader, PickNum)   
global PickWin

result = 0;   % Everything OK
[Conflict, index] = LookForHeaderConflict(Header,PickNum);

if Conflict
   result = ShowPickErrorMsg('Previous pick uses same header as this pick.');
   if result == 1      % rollback new header if not same as old header
      if strcmp(Header, OldHeader)   % nothing to roll back to
         DeletePick(PickNum)
         return
      end
      SetSeisHeader(OldHeader, PickNum)
   elseif result == 2    % kill old pick
      DeletePick(index)
   else
      return     % modify current pick
   end
end







function result = ValidatePhase(Phase, OldPhase, PickNum)   
global PickWin

result = 0;
[Conflict, index] = LookForPhaseConflict(Phase, PickNum);
if Conflict
   result = ShowPickErrorMsg('Previous pick uses same phase as this pick.');
   if result == 1      % Delete This Phase
      if strcmp(Phase, OldPhase)   % nothing to roll back to
         DeletePick(PickNum)
         return
      end
      SetSeisPhase( Phase, PickNum)
   elseif result == 2    % kill old pick
      DeletePick(index)
   else
      return     % modify current pick
   end
end

% --------------------------------------------------------------------






function result = ShowPickErrorMsg(string)
global Selected
% result = 1 ==> Cancel
% result = 2 ==> Kill Old
% result = 3 ==> Modify

hMsg = msgbox(string,'Pick error!','error','modal');

% Get handle to button of the message box and change text and add callback
h = get(hMsg,'children');
for j=1:length(h)
   type = get(h(j),'type');
   if strcmp(type,'uicontrol') 
      style = get(h(j),'style');
      if strcmp(style,'pushbutton')
         hButton = h(j);
         break;
      end
   end
end
set(hButton,'String','Kill Old')
set(hButton,'Callback','global Selected , Selected = 2; close')


Nbuttons = 3;
Pos = get(hMsg,'position');
W = Pos(3);
btnWidth = 75;
spce = (W - Nbuttons * btnWidth) / (Nbuttons + 1);

% reposition button 1
pos = get(hButton,'position');
pos(3) = btnWidth;
pos(1) = spce;
set(hButton,'position',pos)

posNewBtn = pos;
posNewBtn(1) = btnWidth + 2 * spce;
b = uicontrol('Parent',hMsg, ...
	'Units','points', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',posNewBtn, ...
	'String','Modify', ...
	'Callback','global Selected , Selected = 3; close');

posNewBtn = pos;
posNewBtn(1) = 2 * btnWidth + 3 * spce;
b = uicontrol('Parent',hMsg, ...
	'Units','points', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',posNewBtn, ...
	'String','Cancel', ...
	'Callback','global Selected , Selected = 1; close');
	
Selected = 0;	
while Selected ~= 1 & Selected ~= 2 & Selected ~= 3
   drawnow
end
result = Selected ;	
% --------------------------------------------------------------------






function result = FirstAvailableHeader
global PickWin

hHeaderList = findobj('Tag','prsPickWinHdrPopUp');
string = get(hHeaderList,'string');

result = 'T9';
for j=1:length(string)
   Used = 0;
   for k=1:PickWin.Npicks
      if strcmp(PickWin.Pick(k).Header, string(j) )
         Used = 1;
         break;
      end
   end
   if ~Used
      result = string(j);
      return
   end
end

% --------------------------------------------------------------------





function CreateNewPick(Time)
global Seis
global PlotState
global ScaleFactor
global PhaseList
global PickWin
global LastPhaseSet
global CursorPos

TrceNum = PickWin.IndexArray(PickWin.Current);
CursorPos = get(gcf,'CurrentPoint');

% First create pick in PickWin window...
PickWin.Npicks = PickWin.Npicks + 1;
PickWin.PickNum = PickWin.Npicks;
N = PickWin.PickNum;
Pos = get(gca,'CurrentPoint');
Phase = GetDefaultPhase(Time, Pos(1,2));
LastPhaseSet = Phase;


PickWin.Pick(N).Phase = Phase;
PickWin.Pick(N).Header = [];
Header = FirstAvailableHeader;
PickWin.Pick(N).Header = Header;
ylim = get(gca,'ylim');
range = ylim(2) - ylim(1);
PickMarkerSize = range / 5;
lower = ylim(1) + 2 * PickMarkerSize;
upper = ylim(1) + 3 * PickMarkerSize;
PickLim = [lower upper];

PickWin.Pick(N).Text1 = text(Time,lower, PickWin.Pick(N).Phase,...
                                   'erasemode','xor','clipping','on');
PickWin.Pick(N).Text2 = text(Time,upper,PickWin.Pick(N).Header,...
                                   'erasemode','xor','clipping','on'); 
PickWin.Pick(N).LineHandle = line([Time Time], PickLim,'color','r',...
                                        'erasemode','xor');
hc = gca;

h = findobj('Tag','RecSecAxis');
axes(h)
% Now create pick in main record sec window...
if PlotState.ShowPicks
   visible = 'on';
else
   visible = 'off';
end      

if strcmp(PlotState.DistanceUnits , 'Degrees')
   center = Seis(TrceNum).Gcarc;
else
   center = Seis(TrceNum).Dist;
end
   
Seis(TrceNum).Npicks = N;  
T = [ Time Time ];
if strcmp(PlotState.TimeUnits , 'Minutes')
   Seis(TrceNum).Pick(N).Time = Time * 60;
else
   Seis(TrceNum).Pick(N).Time = Time;
end   

R = [ center-ScaleFactor/4 center+ScaleFactor/4];
Seis(TrceNum).Pick(N).LineHandle = line(T, R, 'color','r',...
                        'erasemode','xor', 'visible',visible);

Seis(TrceNum).Pick(N).Header = PickWin.Pick(N).Header;
Seis(TrceNum).Pick(N).Phase = PickWin.Pick(N).Phase;
  
Seis(TrceNum).Pick(N).TextHandle = text(T(1),R(1),PickWin.Pick(N).Header,...
                        'fontsize',8,'erasemode','xor','clipping','on',...
                         'visible',visible);
axes(hc)

% Now see if new pick conflicts with any priors. If so, allow modification.

[Conflict1, index] = LookForHeaderConflict(Header,N);
[Conflict2, index] = LookForPhaseConflict(Phase,N);
if Conflict1 
   OldHeader = ' ';
   ModifyHeader
   Header = PickWin.Pick(PickWin.PickNum).Header;
   ModifyIt = ValidateHeader(Header, OldHeader, PickWin.PickNum);
   while ModifyIt == 3     % modify by hand
      ModifyHeader
      Header = PickWin.Pick(PickWin.PickNum).Header;
      ModifyIt = ValidateHeader(Header, OldHeader, PickWin.PickNum);
   end
end    
if Conflict2
   OldPhase=' ';
   ModifyPhase
   Phase = PickWin.Pick(PickWin.PickNum).Phase;
   ModifyIt = ValidatePhase(Phase, OldPhase, PickWin.PickNum);
   while ModifyIt == 3     % modify selection by hand
      ModifyPhase
      Phase = PickWin.Pick(PickWin.PickNum).Phase;
      ModifyIt = ValidatePhase(Phase, OldPhase, PickWin.PickNum);
   end
end   

% --------------------------------------------------------------------






function Phase = GetDefaultPhase(Time,center)
global PhaseList
global LastPhaseSet

if PhaseList.NumPhases > 0
   for j=1:PhaseList.NumPhases
      Xdata = get(PhaseList.hPhase(j),'Xdata');
      Ydata = get(PhaseList.hPhase(j),'Ydata');
      dx = Xdata - Time;
      dy = Ydata - center;
      Dist2 = dx .^2 + dy .^ 2;
      dmin(j) = min( Dist2 );
   end
   [gmin, ii] = min(dmin);
   Phase = PhaseList.DisplayedPhase{ii};
else
   Phase = LastPhaseSet;       
end   
% --------------------------------------------------------------------




  