function prsSetPicksMouseCallBacks(value)
global ToolBarBtn
global Seis
global PlotState
global PickSelected
global CurrentTrace
global CurrentPick
global PhasePatch
global WaitForPick
global PickWin

MagFactor = 2.0;
h = gcf;
if ~strcmp(get(h,'Tag'),'RecSecPlot'),return,end

h = gca;
if ~strcmp(get(h,'Tag'),'RecSecAxis'),return,end

xlimits = get(gca,'xlim');
ylimits = get(gca,'ylim');
switch value
   case 'btnDown'
       hObj = gco;
       if ~isempty(PickWin)
          if hObj == PickWin.Draghandle
             PickWin.DragWin = 1;
             return
          elseif hObj == PickWin.ULhandle
             PickWin.ULResize = 1;
             return
          elseif hObj == PickWin.URhandle
             PickWin.URResize = 1;
             return
          elseif hObj == PickWin.LLhandle
             PickWin.LLResize = 1;
             return
          elseif hObj == PickWin.LRhandle
             PickWin.LRResize = 1;
             return
          end
       end
       
       if ClickedOnPhaseLine(hObj)
          if strcmp(get(gcf,'selectiontype'),'normal')
             if ToolBarBtn(8)
                MovePhasePatch(hObj)
                SetPickHeaderID(hObj)
             else
                SetPickHeaderID(hObj)
             end
             return
           elseif strcmp(get(gcf,'selectiontype'),'extend')
             SetPicksInsidePhasePatch(hObj)
             return
         elseif strcmp(get(gcf,'selectiontype'),'alt')
             DisplayPhaseLineInfo(hObj)
             return
          else
             return
          end
       end
       
       if ToolBarBtn(1)
         [TrceNum, PickNum] = ClickedOnPick(hObj);
         if TrceNum > 0
            if strcmp(get(gcf,'selectiontype'),'normal')
               PickSelected = 1;
               CurrentTrace = TrceNum;
               CurrentPick = PickNum;
               return
            elseif strcmp(get(gcf,'selectiontype'),'alt')
               DeleteThisPick(TrceNum, PickNum)
               return
	    elseif strcmp(get(gcf,'selectiontype'),'extend')
	       ModifyThisPick(TrceNum, PickNum)
	       return               
            else
               return
            end
         end
       
         StartPoint = get(gca,'currentpoint');
         if StartPoint(1,1) < xlimits(1) | StartPoint(1,1) > xlimits(2)
            return
         end
         if StartPoint(1,2) < ylimits(1) | StartPoint(1,2) > ylimits(2)
            return
         end
         
         if strcmp(get(gcf,'selectiontype'),'alt')
            PopOffStack
            return
         end
         rect = rbbox;
         if rect(3) ~= 0 & rect(4) ~= 0
            EndPoint = get(gca,'currentpoint');
            AddToStack(xlimits,ylimits);
            Xlim = [StartPoint(1,1),EndPoint(1,1)];
            if Xlim(1) > Xlim(2), Xlim = fliplr(Xlim);end
            Ylim = [StartPoint(2,2),EndPoint(2,2)];
            if Ylim(1) > Ylim(2), Ylim = fliplr(Ylim);end
            set(gca,'xlim',Xlim )
            set(gca,'ylim',Ylim )
            hh = findobj('Tag','HscrollBar');
            set(hh,'visible','on')
            
            hv = findobj('Tag','VscrollBar');
            set(hv,'visible','on')
            SetSliderLimits(hh, Xlim, hv, Ylim)
            
            
         end
         return
       end
         
       if ToolBarBtn(2)	% ------------- Magnify trace -----------
          
          ii = TraceHandle( hObj );
          if isempty(ii), return,end
          ydata = get(Seis(ii).TraceHandle,'ydata');
          dist = mean(ydata);
          ydata = (ydata - dist) * MagFactor + dist;
          set(Seis(ii).TraceHandle,'ydata',ydata);
          return
       end

         
       if ToolBarBtn(3)	% ------------- shrink trace -----------
          ii = TraceHandle( hObj );
          if isempty(ii), return,end
          ydata = get(Seis(ii).TraceHandle,'ydata');
          dist = mean(ydata);
          ydata = (ydata - dist) / MagFactor + dist;
          set(Seis(ii).TraceHandle,'ydata',ydata);
          return
       end

       if ToolBarBtn(4) % ------------- make trace visible --------
          ii = NullHandle( hObj );
          if isempty(ii), return,end

          h = findobj('Tag','EventStationMap');
          if ~isempty(h)
             h = findobj('Tag','EvStaMapExcludeV'); 
             if isempty(h),return,end
             if get(h,'value') & Seis(ii).Cmpinc == 0,return,end
             if ~isempty(Seis(ii).MapSta)
                set(Seis(ii).MapSta,'color','b')
             end
             if ~isempty(Seis(ii).MapEvent)
                set(Seis(ii).MapEvent,'color','b')
             end
          end
          
          set(Seis(ii).TraceMarker,'visible','off')
          set(Seis(ii).TraceHandle,'visible','on')
          if PlotState.ShowPicks
             for k=1:Seis(ii).Npicks
                set(Seis(ii).Pick(k).LineHandle,'visible','on')
                set(Seis(ii).Pick(k).TextHandle,'visible','on')
             end
          end
          if PlotState.ShowNames
             set(Seis(ii).NameHandle,'visible','on')
          end   
          Seis(ii).Hidden = 0;
             
          return
       end


       if ToolBarBtn(5)   % ------------- hide trace --------
          ii = TraceHandle( hObj );
          if isempty(ii), return,end
          for k=1:Seis(ii).Npicks
             set(Seis(ii).Pick(k).LineHandle,'visible','off')
             set(Seis(ii).Pick(k).TextHandle,'visible','off')
          end
          set(Seis(ii).NameHandle,'visible','off')   
          if PlotState.ShowPlaceHolders
             set(Seis(ii).TraceMarker,'visible','on')
          end
          set(hObj,'visible','off')
          Seis(ii).Hidden = 1;
          h = findobj('Tag','EventStationMap');
          if ~isempty(h)
             if ~isempty(Seis(ii).MapSta)
                set(Seis(ii).MapSta,'color',[.7 .7 .7])
             end
             if ~isempty(Seis(ii).MapEvent)
                set(Seis(ii).MapEvent,'color',[.7 .7 .7])
             end
          end
          return
       end
       
       if ToolBarBtn(8)
         [TrceNum, PickNum] = ClickedOnPick(hObj);
         if TrceNum > 0
            if strcmp(get(gcf,'selectiontype'),'normal')
               PickSelected = 1;
               CurrentTrace = TrceNum;
               CurrentPick = PickNum;
               return
            elseif strcmp(get(gcf,'selectiontype'),'alt')
               DeleteThisPick(TrceNum, PickNum)
               return
	    elseif strcmp(get(gcf,'selectiontype'),'extend')
	       ModifyThisPick(TrceNum, PickNum)
	       return               
            else
               return
            end
         end
         
         if hObj == PhasePatch.handle
            if strcmp(get(gcf,'selectiontype'),'normal')
               ExtendPatch
            elseif strcmp(get(gcf,'selectiontype'),'extend')
               HidePatch
            elseif strcmp(get(gcf,'selectiontype'),'alt')
               ShrinkPatch
            end
            return   
         end
         
         [TrceNum, Time] = ClickedOnSeismogram(hObj);
         if TrceNum > 0
            CreateNewPick(TrceNum, Time)
            return
         end
       
       
       end
       

   case 'hScroll'
       ScrollHorizontal
       
   case 'vScroll'
       ScrollVertical
       
   case 'btnMove'
   
      if ~isempty(PickWin)
         h = findobj('Tag' ,'RecSecAxis');
         if PickWin.DragWin
            P = get(h,'CurrentPoint');
            PickWin.NewT = P(1,1);
            PickWin.NewD = P(1,2);
            prsPickWin('MoveTo')
            return
         elseif PickWin.ULResize | PickWin.URResize |PickWin.LLResize | PickWin.LRResize
            P = get(h,'CurrentPoint');
            PickWin.NewT = P(1,1);
            PickWin.NewD = P(1,2);
            prsPickWin('Resize')
         end
      end
      
      if PickSelected
         P = get(gca,'CurrentPoint');
         NewTime = [P(1,1) P(1,1)];
         set(Seis(CurrentTrace).Pick(CurrentPick).LineHandle,'Xdata',NewTime)
         Position = get(Seis(CurrentTrace).Pick(CurrentPick).TextHandle,'Position');
         Position(1) = P(1,1);
         set(Seis(CurrentTrace).Pick(CurrentPick).TextHandle,'Position',Position)
         if strcmp(PlotState.TimeUnits , 'Minutes')
            Seis(CurrentTrace).Pick(CurrentPick).Time = P(1,1) * 60;
         else
            Seis(CurrentTrace).Pick(CurrentPick).Time = P(1,1);
         end
         
         hPickAxis = findobj('Tag','PickingAxis');
         if ~isempty(hPickAxis)
            I = PickWin.IndexArray(PickWin.Current);
            if I == CurrentTrace
               set(PickWin.Pick(CurrentPick).LineHandle,'Xdata',NewTime)
               Pos = get(PickWin.Pick(CurrentPick).Text1,'Position');
               Pos(1) = P(1,1);
               set(PickWin.Pick(CurrentPick).Text1,'Position',Pos)
               Pos = get(PickWin.Pick(CurrentPick).Text2,'Position');
               Pos(1) = P(1,1);
               set(PickWin.Pick(CurrentPick).Text2,'Position',Pos)
            end
         end 
      end
   
      h = findobj('Tag','pickMarkerPopUp');
      if isempty(h),return,end
      if OutSideOf(h) & ~WaitForPick 
         set(h,'visible','off')
      end
  
   
   case 'btnUp'
      if PickSelected, PickSelected = 0; end
      
      if ~isempty(PickWin)
         if PickWin.DragWin
            PickWin.DragWin = 0;
            prsPickWin('ValidateDrag')
            return
         elseif PickWin.ULResize
            PickWin.ULResize = 0;
            prsPickWin('ValidateDrag')
            return
         elseif PickWin.URResize
            PickWin.URResize = 0;
            prsPickWin('ValidateDrag')
            return
         elseif PickWin.LLResize
            PickWin.LLResize = 0;
            prsPickWin('ValidateDrag')
            return
         elseif PickWin.LRResize
            PickWin.LRResize = 0;
            prsPickWin('ValidateDrag')
            return
         end
      end
      
      h = findobj('Tag','phaseIDPopUp');
      if isempty(h),return,end
      set(h,'visible','off')
      
      h = findobj('Tag','pickMarkerPopUp');
      if isempty(h),return,end
      if OutSideOf(h)
         set(h,'visible','off')
      end
      
   case 'ChangeHeaderName'
      ChangeHeaderName
  
end   
% --------------------------------------------------------------------







 
 
 
 
function AddToStack(xlimits,ylimits)
global NumZooms
global XstackManPick
global YstackManPick

NumZooms = NumZooms + 1;
XstackManPick(NumZooms,:) = xlimits;
YstackManPick(NumZooms,:) = ylimits;
% --------------------------------------------------------------------









function PopOffStack
global NumZooms
global XstackManPick
global YstackManPick

if NumZooms < 1, return, end

set(gca,'xlim', XstackManPick(NumZooms,:) );
set(gca,'ylim', YstackManPick(NumZooms,:) );
NumZooms = NumZooms -1;

if NumZooms == 0
   h = findobj('Tag','HscrollBar');
   set(h,'visible','off')
   h = findobj('Tag','VscrollBar');
   set(h,'visible','off')
   
end
% --------------------------------------------------------------------







function SetSliderLimits(hSlider, xlim, vSlider, ylim)
global NumZooms
global XstackManPick
global YstackManPick



CurrentWidth = xlim(2) - xlim(1);
OriginalWidth = XstackManPick(1,2) - XstackManPick(1,1);
MinVal = XstackManPick(1,1) +  CurrentWidth / 2;
MaxVal = XstackManPick(1,2) -  CurrentWidth / 2;
set(hSlider,'Min',MinVal, 'Max', MaxVal)
set(hSlider,'Value', ( xlim(2) + xlim(1) ) / 2 );

CurrentHeight = ylim(2) - ylim(1);
OriginalHeight =  YstackManPick(1,2) - YstackManPick(1,1);
MinVal = YstackManPick(1,1) +  CurrentHeight / 2;
MaxVal = YstackManPick(1,2) -  CurrentHeight / 2;
set(vSlider,'Min',MinVal, 'Max', MaxVal)
set(vSlider,'Value', ( ylim(2) + ylim(1) ) / 2 );
% --------------------------------------------------------------------








function ScrollHorizontal
global NumZooms
global XstackManPick
global YstackManPick

h = findobj('Tag','HscrollBar');
v = get(h,'value');
Xlim = get(gca,'xlim');
CurrentCenter = mean( Xlim );
Xlim = Xlim + v - CurrentCenter;
set(gca,'Xlim', Xlim);
% --------------------------------------------------------------------





function ScrollVertical
global NumZooms
global XstackManPick
global YstackManPick

h = findobj('Tag','VscrollBar');
v = get(h,'value');
Ylim = get(gca,'ylim');
CurrentCenter = mean( Ylim );
Ylim = Ylim + v - CurrentCenter;
set(gca,'Ylim', Ylim);
% --------------------------------------------------------------------






function value = ClickedOnPhaseLine(hObj)
global PhaseList

for j=1:PhaseList.NumPhases
   if PhaseList.hPhase(j) == hObj
      value = 1;
      return
   end
end
value = 0;
% --------------------------------------------------------------------






function SetPickHeaderID(hObj)
global PhaseList
global SelectedPhase

index = 0;
for j=1:PhaseList.NumPhases
   if PhaseList.hPhase(j) == hObj
      index = j;
      break
   end
end
if ~index
    return
end    
SelectedPhase = index;


h = findobj('Tag','pickMarkerPopUp');
pos = get(h,'position');
figPos = get(gcf,'currentpoint');
pos(1:2) = figPos;

set(h,'value',PhaseList.HeaderName(index))
set(h,'position',pos)
set(h,'visible','on')

% --------------------------------------------------------------------






function DisplayPhaseLineInfo(hObj)
global PhaseList
index = 0;
for j=1:PhaseList.NumPhases
   if PhaseList.hPhase(j) == hObj
      index = j;
      break
   end
end
if ~index
    return
end    
phase = PhaseList.DisplayedPhase{index};
hdrIndex = PhaseList.HeaderName(index);

h = findobj('Tag','pickMarkerPopUp');
if isempty(h), return, end
string = get(h,'string');
header = string{hdrIndex};
String = ['Phase is: ' char(phase) ', stored in header: ' char(header)];
h = findobj('Tag','phaseIDPopUp');
pos = get(h,'position');
figPos = get(gcf,'currentpoint');
pos(1:2) = figPos;

set(h,'string',String)
set(h,'position',pos)
set(h,'visible','on')
% --------------------------------------------------------------------






function result = OutSideOf(handle)

bounds = get(handle,'position');
Pos = get(gcf,'currentpoint');
result = 1;
if Pos(1) < bounds(1) | Pos(1) > bounds(1) + bounds(3)
   return
end

if Pos(2) < bounds(2) | Pos(2) > bounds(2) + bounds(4)
   return
end

result = 0;
return      

% --------------------------------------------------------------------






function ChangeHeaderName
global PhaseList
global SelectedPhase
global WaitForPick

if WaitForPick
   WaitForPick = 0;
   return
end


h = findobj('Tag','pickMarkerPopUp');
id = get(h,'value');
PhaseList.HeaderName(SelectedPhase) = id;
set(h,'visible','off')
% --------------------------------------------------------------------






function ii = TraceHandle( hObj )
global Seis

ii = [];
for j=1:length(Seis)
   if Seis(j).TraceHandle == hObj
      ii = j;
      return;
   end
end
% --------------------------------------------------------------------





   

function ii = NullHandle( hObj )
global Seis

ii = [];
for j=1:length(Seis)
   if Seis(j).TraceMarker == hObj
      ii = j;
      return;
   end
end
% --------------------------------------------------------------------






function [TrceNum, PickNum] = ClickedOnPick(hObj)
global Seis

TrceNum = 0;
PickNum = 0;
for j=1:length(Seis)
   for k=1:Seis(j).Npicks
      if Seis(j).Pick(k).LineHandle == hObj | Seis(j).Pick(k).TextHandle == hObj
         TrceNum = j;
         PickNum = k;
         return;
      end
   end
end



% --------------------------------------------------------------------






function DeleteThisPick(TrceNum, PickNum)
global Seis
global PickWin

delete(Seis(TrceNum).Pick(PickNum).LineHandle)
delete(Seis(TrceNum).Pick(PickNum).TextHandle)
Seis(TrceNum).Pick(PickNum) = [];
Seis(TrceNum).Npicks = Seis(TrceNum).Npicks - 1;

% Now remove the pick from the PickWin if it exists
hPickAxis = findobj('Tag','PickingAxis');
if ~isempty(hPickAxis)
   I = PickWin.IndexArray(PickWin.Current);
   if I == TrceNum
      delete(PickWin.Pick(PickNum).LineHandle)
      delete(PickWin.Pick(PickNum).Text1)
      delete(PickWin.Pick(PickNum).Text2)
      PickWin.Pick(PickNum) = [];
      PickWin.Npicks = PickWin.Npicks - 1;
   end

end 

% --------------------------------------------------------------------






function ExtendPatch
global PhasePatch
global PickTolerance
global PhaseList

ExpandFactor = 1.5;

h = PhaseList.hPhase(PhasePatch.PhaseIndex);
Xdata = get(h,'Xdata');
Ydata = get(h,'Ydata');
PickTolerance = PickTolerance * ExpandFactor;
X = [Xdata+PickTolerance, fliplr(Xdata)-PickTolerance];
Y = [Ydata, fliplr(Ydata)];
set(PhasePatch.handle,'Xdata',X)
set(PhasePatch.handle,'Ydata',Y)
% --------------------------------------------------------------------




function ShrinkPatch
global PhasePatch
global PickTolerance
global PhaseList

ShrinkFactor = 2/3;

h = PhaseList.hPhase(PhasePatch.PhaseIndex);
Xdata = get(h,'Xdata');
Ydata = get(h,'Ydata');
PickTolerance = PickTolerance * ShrinkFactor;
X = [Xdata+PickTolerance, fliplr(Xdata)-PickTolerance];
Y = [Ydata, fliplr(Ydata)];
set(PhasePatch.handle,'Xdata',X)
set(PhasePatch.handle,'Ydata',Y)
% --------------------------------------------------------------------





function HidePatch
global PhasePatch

set(PhasePatch.handle,'visible','off')
% --------------------------------------------------------------------






function MovePhasePatch(hObj)
global PhasePatch
global PickTolerance
global PhaseList

index = 0;
for j=1:PhaseList.NumPhases
   if PhaseList.hPhase(j) == hObj
      index = j;
      break
   end
end
if ~index
    return
end

h = PhaseList.hPhase(index);
Xdata = get(h,'Xdata');
Ydata = get(h,'Ydata');
X = [Xdata+PickTolerance, fliplr(Xdata)-PickTolerance];
Y = [Ydata, fliplr(Ydata)];
set(PhasePatch.handle,'Xdata',X)
set(PhasePatch.handle,'Ydata',Y)
set(PhasePatch.handle,'visible','on')
PhasePatch.PhaseIndex = index;
PhasePatch.HeaderName = PhaseList.HeaderName(index);
PhasePatch.DisplayedPhase = PhaseList.DisplayedPhase{index};
% --------------------------------------------------------------------








function [TrceNum, Time] = ClickedOnSeismogram(hObj)
global Seis

TrceNum = 0;
Time = 0;
for j=1:length(Seis)
   if Seis(j).TraceHandle == hObj
      TrceNum = j;
      point = get(gca,'CurrentPoint');
      Time = point(1,1);
      return;
   end
end
% --------------------------------------------------------------------






function ModifyThisPick(TrceNum, PickNum)
global Seis
global PhaseList
global WaitForPick
global PickWin

% Display pick popup after first setting its default to current value.
   hPickList = findobj('Tag','PickList');
   if ~hPickList, return, end
   string = get(hPickList,'string');
   P = get(gcf,'CurrentPoint');
   Pos = get(hPickList,'Position');
   Pos(1) = P(1);
   Pos(2) = P(2);
   set(hPickList,'Position',Pos);
   index = 1;
   for j=1:length(string)
      if strcmp(string(j), Seis(TrceNum).Pick(PickNum).Phase)
         index = j;
         break;
      end
   end
   set(hPickList,'Value',index)
   set(hPickList,'Visible','on')
   % The pick popup is now displayed. Go into an endless loop which is terminated
   % by a callback from the popup control
   WaitForPick = 1;
   while WaitForPick
      drawnow
      if ~WaitForPick,break,end
   end
   Seis(TrceNum).Pick(PickNum).Phase = string( get(hPickList,'value') );
   set(hPickList,'Visible','off')


% Display header popup after first setting its default to current value.
   hHeaderList = findobj('Tag','pickMarkerPopUp');
   if ~hHeaderList, return,end
   Pos = get(hHeaderList,'Position');
   Pos(1) = P(1);
   Pos(2) = P(2);
   set(hHeaderList,'Position',Pos);
   string = get(hHeaderList,'string');
   index = 1;
   for j=1:length(string)
      if strcmp(string(j), Seis(TrceNum).Pick(PickNum).Header)
         index = j;
         break;
      end
   end
   set(hHeaderList,'Value',index)
   set(hHeaderList,'Visible','on')      
   WaitForPick = 1;
   while WaitForPick
      drawnow
      if ~WaitForPick,break,end
   end
   Seis(TrceNum).Pick(PickNum).Header = string( get(hHeaderList,'value') );
   set(Seis(TrceNum).Pick(PickNum).TextHandle,'string',...
       Seis(TrceNum).Pick(PickNum).Header);
   set(hHeaderList,'Visible','off')
   
   hPickAxis = findobj('Tag','PickingAxis');
   if ~isempty(hPickAxis)
      I = PickWin.IndexArray(PickWin.Current);
      if I == TrceNum
         set(PickWin.Pick(PickNum).Text1,'string',Seis(TrceNum).Pick(PickNum).Phase)
         set(PickWin.Pick(PickNum).Text2,'string',Seis(TrceNum).Pick(PickNum).Header)
      end
   end
   
   ValidateNewPick(TrceNum)      				


% --------------------------------------------------------------------







function CreateNewPick(TrceNum, Time)
global Seis
global PlotState
global ScaleFactor
global PhaseList
global PickWin
global LastPhaseSet


if ~PlotState.ShowPicks, return, end

if strcmp(PlotState.DistanceUnits , 'Degrees')
   center = Seis(TrceNum).Gcarc;
else
   center = Seis(TrceNum).Dist;
end
   
Seis(TrceNum).Npicks =  Seis(TrceNum).Npicks + 1;  
T = [ Time Time ];
if strcmp(PlotState.TimeUnits , 'Minutes')
   Seis(TrceNum).Pick(Seis(TrceNum).Npicks).Time = Time * 60;
else
   Seis(TrceNum).Pick(Seis(TrceNum).Npicks).Time = Time;
end   

R = [ center-ScaleFactor/4 center+ScaleFactor/4];
Seis(TrceNum).Pick(Seis(TrceNum).Npicks).LineHandle = line(T, R, 'color','r','erasemode','xor');



Seis(TrceNum).Pick(Seis(TrceNum).Npicks).Header = [];
Seis(TrceNum).Pick(Seis(TrceNum).Npicks).Phase = [];

[DisplayedPhase, header] = GetPhaseAndHeader(center, Time,TrceNum);
Seis(TrceNum).Pick(Seis(TrceNum).Npicks).Header = header;
Seis(TrceNum).Pick(Seis(TrceNum).Npicks).Phase = DisplayedPhase;
LastPhaseSet = DisplayedPhase;  
Seis(TrceNum).Pick(Seis(TrceNum).Npicks).TextHandle = text(T(1), R(1),header,...
      				'fontsize',8,'erasemode','xor','clipping','on');

% Now add the pick to the PickWin if it exists
hPickAxis = findobj('Tag','PickingAxis');
if ~isempty(hPickAxis)
   I = PickWin.IndexArray(PickWin.Current);
   if I == TrceNum
      PickWin.Npicks = PickWin.Npicks + 1;
      PickWin.PickNum = PickWin.Npicks;
      N = PickWin.PickNum;
      PickWin.Pick(N).Phase = DisplayedPhase;
      PickWin.Pick(N).Header = header;
      ylim = get(hPickAxis,'ylim');
      range = ylim(2) - ylim(1);
      PickMarkerSize = range / 5;
      lower = ylim(1) + 2 * PickMarkerSize;
      upper = ylim(1) + 3 * PickMarkerSize;
      PickLim = [lower upper];

      PickWin.Pick(N).Text1 = text(Time,lower,PickWin.Pick(N).Phase,... 
                                    'erasemode','xor','clipping','on','parent',hPickAxis);
      PickWin.Pick(N).Text2 = text(Time,upper,PickWin.Pick(N).Header,...
                                   'erasemode','xor','clipping','on','parent',hPickAxis); 
      PickWin.Pick(N).LineHandle = line([Time Time],PickLim,'color','r',...
                                    'erasemode','xor','parent',hPickAxis);
   end

end 


% Now need to see if the chosen phase is already in use, or if the header is in use.
      				
ValidateNewPick(TrceNum)      				
% --------------------------------------------------------------------






function CreateNewAutoPick(TrceNum, Time, DisplayedPhase, header)
global Seis
global PlotState
global ScaleFactor
global PhaseList
global PickWin

if ~PlotState.ShowPicks, return, end

if strcmp(PlotState.DistanceUnits , 'Degrees')
   center = Seis(TrceNum).Gcarc;
else
   center = Seis(TrceNum).Dist;
end
   
Seis(TrceNum).Npicks =  Seis(TrceNum).Npicks + 1;  
T = [ Time Time ];
 
if strcmp(PlotState.TimeUnits , 'Minutes')
   Seis(TrceNum).Pick(Seis(TrceNum).Npicks).Time = Time * 60;
else
   Seis(TrceNum).Pick(Seis(TrceNum).Npicks).Time = Time;
end   

R = [ center-ScaleFactor/4 center+ScaleFactor/4];
Seis(TrceNum).Pick(Seis(TrceNum).Npicks).LineHandle = line(T, R, 'color','r','erasemode','xor');
if Seis(TrceNum).Hidden
   set(Seis(TrceNum).Pick(Seis(TrceNum).Npicks).LineHandle,'visible','off')
end   
Seis(TrceNum).Pick(Seis(TrceNum).Npicks).Header = header;
Seis(TrceNum).Pick(Seis(TrceNum).Npicks).Phase = DisplayedPhase;
  
Seis(TrceNum).Pick(Seis(TrceNum).Npicks).TextHandle = text(T(1), R(1),header,...
      				'fontsize',8,'erasemode','xor','clipping','on');
if Seis(TrceNum).Hidden
   set(Seis(TrceNum).Pick(Seis(TrceNum).Npicks).TextHandle,'visible','off')
end

   
% Now add the pick to the PickWin if it exists
hPickAxis = findobj('Tag','PickingAxis');
if ~isempty(hPickAxis)
   I = PickWin.IndexArray(PickWin.Current);
   if I == TrceNum
      PickWin.Npicks = PickWin.Npicks + 1;
      PickWin.PickNum = PickWin.Npicks;
      N = PickWin.PickNum;
      PickWin.Pick(N).Phase = DisplayedPhase;
      PickWin.Pick(N).Header = header;
      ylim = get(hPickAxis,'ylim');
      range = ylim(2) - ylim(1);
      PickMarkerSize = range / 5;
      lower = ylim(1) + 2 * PickMarkerSize;
      upper = ylim(1) + 3 * PickMarkerSize;
      PickLim = [lower upper];

      PickWin.Pick(N).Text1 = text(Time,lower,PickWin.Pick(N).Phase,... 
                                    'erasemode','xor','clipping','on','parent',hPickAxis);
      PickWin.Pick(N).Text2 = text(Time,upper,PickWin.Pick(N).Header,...
                                   'erasemode','xor','clipping','on','parent',hPickAxis); 
      PickWin.Pick(N).LineHandle = line([Time Time],PickLim,'color','r',...
                                    'erasemode','xor','parent',hPickAxis);
   end

end 
% --------------------------------------------------------------------






function [DisplayedPhase, header] = GetPhaseAndHeader(center, Time,TrceNum)
global PhaseList
global WaitForPick
global LastPhaseSet

% Check to see if pick was set with center button. If so, select phase from drop-down
% list. Then present a drop-down list for header to store in.

%Otherwise, find the closest phase line and set pick and header to its values.
% If there are no phase lines, use first method.
if strcmp(get(gcf,'selectiontype'),'extend') 
   hPickList = findobj('Tag','PickList');
   if ~hPickList, return, end
   P = get(gcf,'CurrentPoint');
   Pos = get(hPickList,'Position');
   Pos(1) = P(1);
   Pos(2) = P(2);
   set(hPickList,'Position',Pos);
   set(hPickList,'Visible','on')
   % The pick popup is now displayed. Go into an endless loop which is terminated
   % by a callback from the popup control
   WaitForPick = 1;
   while WaitForPick
      drawnow
      if ~WaitForPick,break,end
   end
   string = get(hPickList,'string');
   DisplayedPhase = string( get(hPickList,'value') );
   set(hPickList,'Visible','off')

   hHeaderList = findobj('Tag','pickMarkerPopUp');
   Pos = get(hHeaderList,'Position');
   Pos(1) = P(1);
   Pos(2) = P(2);
   set(hHeaderList,'Position',Pos);
   set(hHeaderList,'Visible','on')      
   WaitForPick = 1;
   while WaitForPick
      drawnow
      if ~WaitForPick,break,end
   end
   ii = get(hHeaderList,'value');
   string = get(hHeaderList,'string');
   header = string(ii);
   set(hHeaderList,'Visible','off')
   return
end

   
% If we got to here, then we are setting pick info from phase line. 
% So find the closest displayed phase.

if PhaseList.NumPhases > 0
   for j=1:PhaseList.NumPhases
      Xdata = get(PhaseList.hPhase(j),'Xdata');
      Ydata = get(PhaseList.hPhase(j),'Ydata');
      dx = Xdata - Time;
      dy = Ydata - center;
      Dist2 = dx .^2 + dy .^ 2;
      dmin(j) = min( Dist2 );
   end
   [gmin, ii] = min(dmin);
   DisplayedPhase = PhaseList.DisplayedPhase{ii};
   HeaderName = PhaseList.HeaderName(ii);
   h = findobj('Tag','pickMarkerPopUp');
   if isempty(h), return, end
   string = get(h,'string');
   header = char(string{HeaderName} );
else
   DisplayedPhase = LastPhaseSet;       
   header = FirstAvailableHeader(TrceNum);
end   

LastPhaseSet = DisplayedPhase;

% --------------------------------------------------------------------






function ValidateNewPick(TrceNum)
global Seis
global DeleteNewPick

DeleteNewPick = -1;
Header = Seis(TrceNum).Pick(Seis(TrceNum).Npicks).Header;
Phase = Seis(TrceNum).Pick(Seis(TrceNum).Npicks).Phase;

for j=1:Seis(TrceNum).Npicks -1
   if strcmp(Seis(TrceNum).Pick(j).Header, Header)
      ShowPickErrorMsg('Previous pick uses same header as new pick.')
      if DeleteNewPick
         DeleteThisPick(TrceNum, Seis(TrceNum).Npicks)
      else
         DeleteThisPick(TrceNum, j)
      end
      return
   end
end

DeleteNewPick = -1;
for j=1:Seis(TrceNum).Npicks -1
   if strcmp(Seis(TrceNum).Pick(j).Phase, Phase)
      ShowPickErrorMsg('Previous pick of same phase as new pick.')
      if DeleteNewPick
         KillPick(TrceNum, Seis(TrceNum).Npicks)
      else
         KillPick(TrceNum, j)
      end
      return
   end
end
% --------------------------------------------------------------------









function ShowPickErrorMsg(string)
global DeleteNewPick

hMsg = msgbox(string,'Pick error!','error','modal');

% Add another button to the message box
h = get(hMsg,'children');
for j=1:length(h)
   type = get(h(j),'type');
   if strcmp(type,'uicontrol') 
      style = get(h(j),'style');
      if strcmp(style,'pushbutton')
         hButton = h(j);
         break;
      end
   end
end
set(hButton,'String','Delete Old Pick')
set(hButton,'Callback','global DeleteNewPick, DeleteNewPick = 0; close')
Pos = get(hMsg,'position');
W = Pos(3);
btnWidth = 100;
spce = (W - 2 * btnWidth) / 3;

pos = get(hButton,'position');
pos(3) = btnWidth;
pos(1) = spce;
set(hButton,'position',pos)

posNewBtn = pos;
posNewBtn(1) = btnWidth + 2 * spce;
b = uicontrol('Parent',hMsg, ...
	'Units','points', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',posNewBtn, ...
	'String','Delete New Pick', ...
	'Callback','global DeleteNewPick, DeleteNewPick = 1; close');
	
	
while DeleteNewPick ~= 0 & DeleteNewPick ~= 1
   drawnow
%      if ~WaitForPick,break,end
end
	
% --------------------------------------------------------------------





function SetPicksInsidePhasePatch(hObj)
global Seis
global PhaseList
global PlotState
global PickTolerance

index = 0;
for j=1:PhaseList.NumPhases
   if PhaseList.hPhase(j) == hObj
      index = j;
      break
   end
end
if ~index
    return
end
Phase = char( PhaseList.DisplayedPhase{index} );
hdrIndex = PhaseList.HeaderName(index);
hHeaderList = findobj('Tag','pickMarkerPopUp');
if ~hHeaderList, return,end
string = get(hHeaderList,'string');
Header = string(hdrIndex);
time = get(hObj,'Xdata');
dist = get(hObj,'Ydata');


for j=1:length(Seis)
   if strcmp(PlotState.DistanceUnits , 'Degrees')
      ii = find(Seis(j).Gcarc == dist);
   else
      ii = find(Seis(j).Dist == dist);
   end
   if ii > 0		% seismogram intersects phase curve
      PickTime = time(ii(1));
      
      k=1;
      MatchingPick = 0;
      while k <= Seis(j).Npicks
         if strcmp(Seis(j).Pick(k).Phase, Phase)
            if MatchingPick
                DeleteThisPick(j, k)
            else
               tPos = get(Seis(j).Pick(k).LineHandle,'Xdata');
               if abs( tPos - PickTime ) < PickTolerance
                  Seis(j).Pick(k).Header = Header;
                  set( Seis(j).Pick(k).TextHandle,'string',Header)
                  MatchingPick = 1;
               else
                  DeleteThisPick(j, k)
               end
            end
         elseif strcmp(Seis(j).Pick(k).Header, Header)
            if MatchingPick
                DeleteThisPick(j, k)
            else
               tPos = get(Seis(j).Pick(k).LineHandle,'Xdata');
               if abs( tPos - PickTime ) < PickTolerance
                  Seis(j).Pick(k).Phase = Phase;
                  MatchingPick = 1;
               else
                  DeleteThisPick(j, k)
               end
            end
         end
         k = k + 1;
      end
      if ~MatchingPick
         CreateNewAutoPick(j, PickTime, Phase, Header)
      end
   end
end 
% --------------------------------------------------------------------






function result = FirstAvailableHeader(index)
global Seis

hHeaderList = findobj('Tag','pickMarkerPopUp');
string = get(hHeaderList,'string');

result = 'T9';
for j=1:length(string)
   Used = 0;
   for k=1:Seis(index).Npicks
      if ~isempty(Seis(index).Pick(k).Header)
         if strcmp(Seis(index).Pick(k).Header, string(j) )
            Used = 1;
            break;
         end
      end
   end
   if ~Used
      result = string(j);
      return
   end
end

% --------------------------------------------------------------------

